#include "raylib.h"
#include <stdio.h>
#include <stdlib.h>
#include<math.h>

struct Entity {
    Vector2 pos;
    int r;
    Color color;
    float angle;
    bool active;
};

struct Entity objects[100];
struct Entity player;
int score = 0;
int state = 2;


void drawentity(struct Entity entity) {
    if (entity.active && state==1) {
        Color color = RED;
        DrawCircleV(entity.pos, entity.r, color);
    }
}

int lastindex = -1;
void spawn() {
    lastindex += 1;
    if (lastindex == 100) {
        lastindex = 0;
    }
    int i = lastindex;
    struct Entity obj;
    obj.r = 20;
    obj.active = true;
    Vector2 pos;
    switch (GetRandomValue(0, 3)) {
        case 0:
            pos.x = GetRandomValue(0, 800);
            pos.y = -obj.r;
            break;
        case 1:
            pos.x = GetRandomValue(0, 800);
            pos.y = 800 + obj.r;
            break;
        case 2:
            pos.y = GetRandomValue(0, 800);
            pos.x = -obj.r;
            break;
        case 3:
            pos.y = GetRandomValue(0, 800);
            pos.x = 800 + obj.r;
            break;
        default:
            pos.x = 0;
            pos.y = 0;
    }
    obj.pos = pos;
    int dx, dy;
    dx = (player.pos.x - obj.pos.x);
    dy = (player.pos.y - obj.pos.y);

    obj.angle = atan2(dx, dy);
    objects[i] = obj;
}



int main(void)
{
    const int screenWidth = 800;
    const int screenHeight = 800;

    InitWindow(screenWidth, screenHeight, "Impossible Ball");
    player.r = 20;
    player.active = true;
    player.pos = GetMousePosition();
    
    //for (int i = 0;i < 10;i++) {
    //    spawn();
    //}

    InitAudioDevice();              // Initialize audio device

    Music music = LoadMusicStream("goodmusicr.mp3");

    PlayMusicStream(music);

    

    SetTargetFPS(60);
    int frame = 0;
   
    while (!WindowShouldClose())    // Detect window close button or ESC key
    {
        frame += 1;
        player.pos = GetMousePosition();
        player.r = 20;
        player.color = DARKBLUE;

        UpdateMusicStream(music);
        

        if (frame % 15 == 0 && state == 1) {
            spawn();
        }

        //update
        for (int i = 0;i < 100;i++) {
            struct Entity *obj;
            obj = &objects[i];
            

            obj->pos.x += sin(obj->angle) * 6;
            obj->pos.y += cos(obj->angle) * 6;
            
            //if out
            const int offset = 50;
            if (obj->pos.x > 800+offset || obj->pos.x < 0-offset || obj->pos.y > 800+offset || obj->pos.y < 0-offset) {
                if (obj->active == true) {
                    obj->active = false;
                    score += 1;
                }
            }
        }

        //collision
        for (int i = 0;i < 100;i++) {
            if (state != 1) break;
            struct Entity obj;
            obj = objects[i];
            if (obj.active == false) continue;

            int x = pow((obj.pos.x - player.pos.x), 2);
            int y = pow((obj.pos.y - player.pos.y), 2);

            int dis = sqrt(x + y);

            if (dis < obj.r + player.r) {
                //Color color = RED;
                player.color = RED;
                state = 2;
                for (int i = 0;i < 100;i++) {
                    struct Entity* obj;
                    obj = &objects[i];
                    obj->active = false;

                }

            }
            //free(obj);
        }

        BeginDrawing();

        Color background = { 0, 220, 0 };
        ClearBackground(background);

        

        //drawing
        for (int i = 0;i < 100;i++) {
            struct Entity obj = objects[i];
            drawentity(obj);
        }

        DrawCircleV(player.pos, player.r, player.color);
        
        char str[9];
        sprintf(str, "%d", score);
        DrawText(str, 10, 10, 20, DARKGRAY);

        if (state == 2) {
            DrawText("Click to start the game", 400 - MeasureText("Click to start the game", 20)/2, 400, 20, DARKGRAY);
            if (IsMouseButtonPressed(MOUSE_BUTTON_LEFT)) {
                state = 1;
                score = 0;
            }
        }

        EndDrawing();
        
    }

    UnloadMusicStream(music);          // Unload music stream buffers from RAM

    CloseAudioDevice();

    CloseWindow();        // Close window and OpenGL context

    return 0;
}

